﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using EJ2Grid.Models;
using Syncfusion.EJ2.Base;
using System.Collections;
using System.ComponentModel.DataAnnotations;

namespace EJ2Grid.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public static List<Employee> employee = new List<Employee>();
        public static List<Customer> customer = new List<Customer>();
        public static List<ShipData> shipdata = new List<ShipData>();
        public IActionResult Index()
        {
            if (order.Count == 0)
            {
                BindDataSource();
                ViewBag.datasource = order;
            }
            ViewBag.datasource = order.ToList();
            if (employee.Count == 0)
            {
                employee.Add(new Employee(1, "Michael"));
                employee.Add(new Employee(2, "Anne"));
                employee.Add(new Employee(3, "Janet"));
                employee.Add(new Employee(4, "Andrew"));
                employee.Add(new Employee(5, "Margaret"));
                employee.Add(new Employee(6, "Nancy"));
                employee.Add(new Employee(7, "Robert"));
                employee.Add(new Employee(8, "Laura"));
                employee.Add(new Employee(9, "Steven"));
                employee.Add(new Employee(10, "James"));
                employee.Add(new Employee(11, "Smith"));
                employee.Add(new Employee(12, "Jhonson"));
                employee.Add(new Employee(13, "George"));
            }

            if(customer.Count  == 0) {
                customer.Add(new Customer("ALFKI", "ALAN"));
                customer.Add(new Customer("ANATR", "GEORGE"));
                customer.Add(new Customer("ANTON", "VINET"));
                customer.Add(new Customer("BLONP", "MIKE"));
                customer.Add(new Customer("BOLID", "VIJAY"));
            }

            if (shipdata.Count == 0) {
                shipdata.Add(new ShipData("Berlin", "Aircraft carrier"));
                shipdata.Add(new ShipData("Madrid", "Amphibious warfare"));
                shipdata.Add(new ShipData("Cholchester", "BattleCruiser"));
                shipdata.Add(new ShipData("Marseille", "BattleShip"));
                shipdata.Add(new ShipData("Tsawassen", "Bomb vessel"));
            }
           
            ViewBag.employee = employee;

            return View();
        }

        public IActionResult CustomerData([FromBody]DataManagerRequest dm) {

            IEnumerable DataSource = customer;
            int count = DataSource.Cast<Customer>().Count();
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult EmployeeData([FromBody]DataManagerRequest dm)
        {

            IEnumerable DataSource = employee;
            int count = DataSource.Cast<Employee>().Count();
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }
        public IActionResult ShipDataSrc([FromBody]DataManagerRequest dm)
        {

            IEnumerable DataSource = shipdata;
            int count = DataSource.Cast<ShipData>().Count();
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }


        public IActionResult UrlDatasource([FromBody]DataManagerRequest dm)
        {           
            IEnumerable DataSource = order;
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Orders>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult EditPartial([FromBody] CRUDModel<Orders> value)
        {
            ViewBag.datasource = order;
            ViewBag.employee = employee;
            return PartialView("_DialogEditPartial", value.Value);
        }

        public IActionResult AddPartial()
        {
            ViewBag.datasource = order;
            ViewBag.employee = employee;
            return PartialView("_DialogAddPartial");
        }
        private void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(new Guid(),code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", "Denmark", "1-340"));
                order.Add(new Orders(new Guid(),code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", "Brazil","47"));
                order.Add(new Orders(new Guid(), code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", "Germany","268"));
                order.Add(new Orders(new Guid(),code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", "Austria","1-787"));
                order.Add(new Orders(new Guid(),code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", "Switzerland","44-1624"));
                code += 5;
            }
        }
        public IActionResult Insert([FromBody]CRUDModel<Orders> value)
        {
            order.Insert(0, value.Value);
            return Json(value.Value);
        }
        public IActionResult Update([FromBody]CRUDModel<Orders> value)
        {
            var data = order.Where(or => or.OrderID == value.Value.OrderID).FirstOrDefault();
            if(data != null)
            {
                data.OrderID = value.Value.OrderID;
                data.CustomerID = value.Value.CustomerID;
                data.EmployeeID = value.Value.EmployeeID;
                data.OrderDate = value.Value.OrderDate;
                data.ShipCity = value.Value.ShipCity;
                data.Freight = value.Value.Freight;
            }
            return Json(value.Value);
        }
        public void Remove([FromBody]CRUDModel<Orders> Value)
        {
           var data = order.Where(or => or.OrderID.Equals(Value.Key)).FirstOrDefault();
           order.Remove(data);
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(Guid guid,long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity, string ShipCountry, string countrycode)
            {
                this.guid = guid;
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.ShipCountry = ShipCountry;
                this.countrycode = countrycode;
            }

            public Guid guid { get; set; }

            public long OrderID { get; set; }            
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            public string ShipCountry { get; set; }

            public string countrycode { get; set; }
        }

        [Serializable]
        public class Employee
        {
            public Employee()
            {

            }
            public Employee(int EmployeeId, string FirstName)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
        }

        public class Customer
        {
            public Customer()
            {

            }
            public Customer(string customerId, string CustomerName)
            {
                this.CustomerID = customerId;
                this.CustomerName = CustomerName;
            }
            public string CustomerID { get; set; }
            public string CustomerName { get; set; }
        }

        public class ShipData
        {
            public ShipData()
            {

            }
            public ShipData(string shipcity, string shipname)
            {
                this.ShipCity = shipcity;
                this.ShipName = shipname;
            }
            public string ShipCity { get; set; }
            public string ShipName { get; set; }
        }


    }
}
